program GreatSummator;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  Summator = class
    N : integer;
    constructor Create(newN : integer);
    procedure sum; virtual; abstract;
  end;

  StupidSummator = class(Summator)
    procedure sum; override;
  end;

  SmartSummator = class(Summator)
    procedure sum; override;
  end;

{ SmartSummator }

procedure SmartSummator.sum;
begin
  writeln('SmartSummator: ', (N*(N+1)) div 2);
end;



{ StupidSummator }

procedure StupidSummator.sum;
var i, s : integer;
begin
  s := 0;
  for i := 1 to N do
    s := s + i;
  writeln('StupidSummator: ', s);
end;

{ Summator }

constructor Summator.Create(newN : integer);
begin
  writeln('Privet, Plavnik! A Katia - uzhasnaja ZANUDA!');
  N := newN;
end;

var s : Summator;
    myN : integer;

begin
  readln(myN);

  s := StupidSummator.Create(myN);
  s.sum;

  s := SmartSummator.Create(myN);
  s.sum;

  readln;
end.
